## 3 Hypotenuusan laskeminen

**Tehtävä:**

Tee ohjelma, joka laskee suorakulmaisen kolmion hypotenuusan pituuden ohjelmaan syötettyjen kateettien pituuksien perusteella. Kateettien pituuksien odotetaan olevan kokonaislukuja, kun taas hypotenuusan pituus sijoitetaan double-muuttujaan.

**Vihje:**
Neliöjuuren voi laskea seuraavasti (palauttaa double-tyypin arvon):

```
double juuri = sqrt(double_luku);
```

Tarvitset cmath-kirjastoa.

Example output:

```
Anna ensimmäinen kateetti:34
Anna toinen kateetti:11
Hypotenuusan pituus: 35.7351
```

**Vastaus:**

```
#include <cmath>
#include <iomanip>
#include <iostream>

using namespace std;

int main() {

  int katYksi, katKaksi;
  double double_luku, juuri;

  cout << "Anna ensimmäinen kateetti:";
  cin >> katYksi;
  if (cin.fail()) exit(1);

  cout << "Anna toinen kateetti:";
  cin >> katKaksi;
  if (cin.fail()) exit(1);

  // The assignment expects strictly formatted output

  double_luku = (double)( pow(katYksi, 2) + pow(katKaksi, 2) );
  juuri = sqrt(double_luku);

  cout << "Hypotenuusan pituus:" << " " << setprecision(4) << fixed << juuri << endl;

  return 0;

}
```
