## 1 Piste-luokan määritteleminen

**Tehtävä:**

Olet luvun teoriasivuja lukiessa oppinut, kuinka luokkia yksinkertaisimmillaan määritellään. Nyt tehtävänäsi on laatia määrittely luokalle "Piste", joka sisältää kaksi jäsenmuuttujaa: x- ja y-koordinaatit.

Kyseiset tietojäsenet määritellään kokonaisluvuiksi ja ne nimetään seuraavasti: "x_" ja "y_". Koska pelkin tietojäsenin varustettu luokka on käytännössä käyttökelvoton, esitellään luokan määrittelyssä lisäksi äsenfunktiot "AsetaX", "AsetaY", "Siirra" ja "KerroPaikka".

Koordinaattien arvojen asettamiseen käytettävään funktioita "AsetaX" ja "AsetaY". Funktiot ottavat vastaan niitä kutsuttaessa yhden kokonaislukuarvon sijoittaen tämän arvon funktiosta riippuen, joko jäsenmuuttujaan "x_", tai "y_". Asetusfunktiot eivät palauta arvoja.

Jäsenfunktio "Siirra" ottaa vastaan kaksi kokonaislukuarvoa: x:n ja y:n siirtymät edellisessä järjestyksessä. "Siirra" liikuttaa pisteen koordinaatteja sille välitettyjen parametrien mukaisen määrän. "Siirra" ei palauta arvoa.

Pisteen paikan kertomisesta vastaava funktio tulostaa pisteen koordinaatit allekkain esimerkkitulosteen mukaisesti. Funktiolle "KerroPaikka" ei välitetä parametreja, eikä se palauta arvoa.

Muista, että tässä tehtävässä sinun tulee laatia vain luokan määrittely, joka tarkistetaan liittämällä se valmiisiin jäsenfunktioihin ja pääohjelmaan, joka käyttää luokan palveluita. Muista myös, että luokan määrittelyssä jäsenfunktiot on määriteltävä julkisiksi, kun taas jäsenmuuttujien tulee olla ns. sisäisiä.

Example output:

```
Pisteolio muodostettu ja koordinaatit asetettu.
Pisteen x-koordinaatti: 34
Pisteen y-koordinaatti: 100
Pistettä siirretty.
Pisteen x-koordinaatti: 54
Pisteen y-koordinaatti: 67
```

**Vastaus:**

```
#include<iostream>
using namespace std;

class Piste
{
  public:
    void AsetaX(int x);
    void AsetaY(int y);
    void Siirra(int x, int y);
    void KerroPaikka();

  private:
    int x_;
    int y_;
};

//** Pre-defined code in the assignment **//
void Piste::AsetaX(int x)
{
  x_ = x;
}

void Piste::AsetaY(int y)
{
  y_ = y;
}

void Piste::Siirra(int x, int y)
{
  x_ = x_ + x;
  y_ = y_ + y;
}

void Piste::KerroPaikka()
{
  cout << "Pisteen x-koordinaatti: " << x_ << endl;
  cout << "Pisteen y-koordinaatti: " << y_ << endl;
}

int main()
{
  Piste pikseli;
  pikseli.AsetaX(34);
  pikseli.AsetaY(100);

  cout << "Pisteolio muodostettu ja koordinaatit asetettu.\n"

  pikseli.KerroPaikka();
  pikseli.Siirra(20, -33);

  cout << "Pistettä siirretty.\n"

  pikseli.KerroPaikka();

  return 0;
}
//** ---------- ---------- ---------- **//
```
