## 2 Oliotaulukon käsittely

**Tehtävä:**

Edellisessä tehtävässä sinun vastuulla oli toteuttaa luokka, jonka
palveluiden avulla alkeellinen pankkiohjelma toimi. Nyt tehtävänäsi on
toteuttaa pieni osa "Asiakastili" luokkaa hyödyntävästä pääohjelmasta,
joka kokonaisuudessaan muodostaa pankkiohjelman logiikan ja toiminnan.

Tehtävänäsi on kirjoittaa ohjelmanpätkä, joka liitetään osaksi koko pankkiohjelmaa. Sinun ohjelman osan tulee selvittää, löytyykö köytössäsi olevasta oliotaulukosta oliota eli asiakasta, jolla on sama tilinumero kuin ohjelmalle juuri syötetty tilinumero. Jos oliotaulukko (asiakasrekisteri[5]) sisältää asiakkaan, jolla on sama numero, tulee ohjelman osasi asettaa bool-muuttujalle "loytyi" arvo "true", sekä kutsua täsmäävän olion jäsenfunktiota "NaytaTiedot()".

Seuraavassa huomioita tehtävän ratkaisemiseksi:

- Tilinumero, jota haetaan oliotaulukon olioista sijaitsee muuttujassa "tilin_nro".

- Oliot, joiden seasta etsitään täsmäävää tilinumeroa on nimeltään "asiakasrekisteri" ja se sisältää viisi oliota (asiakasrekisteri[0]-->asiakasrekisteri[4]).

- Tehokkaimmin täsmäävän tilinumeron etsiminen onnistuu silmukassa. Silmukan ehto-osassa on mahdollista määritellä erityinen indeksimuuttuja, esim: for(int indeksi; ....

- Olioiden funktioihin viitataan pistenotaatiolla.

- Ohjelman tulee vain ja ainoastaan verrata olemassa olevaa tilinumeroa olioiden tilinumeroihin ja jos saman tilinumeron omaava olio löytyy, asettaa "loytyi", sekä kutsua "NaytaTiedot" funktiota. Muut toiminnallisuudet ovat turhia ja estävät mahdollisesti tehtävän hyväksytyn suorittamisen.

Example output:

```
1: Näytä asiakkaan tiedot.
2: Muuta asiakkaan saldoa.
Lopetus negatiivisella luvulla.
Valitse toiminto: 1
Anna tilinumero: 
32442
Antamaasi tilinumeroa ei löytynyt.

1: Näytä asiakkaan tiedot.
2: Muuta asiakkaan saldoa.
Lopetus negatiivisella luvulla.
Valitse toiminto: -1

Ohjelma lopetetaan.
```

**Vastaus:**

```
//** Pre-defined code in the assignment **//
#include <iostream>
using namespace std;

class Asiakastili
{
  public:
    void LisaaAsiakas(int tilinumero, int saldo, string nimi);
    void NaytaTiedot();
    int MuutaSaldoa(int saldo);
    int VertaaTiliNro(int vertaatilinumero);

  private:
    int tilinumero_, saldo_;
    string nimi_;
};

void Asiakastili::LisaaAsiakas(int tilinumero, int saldo, string nimi)
{
  tilinumero_ = tilinumero;
  saldo_      = saldo;
  nimi_       = nimi;
}

void Asiakastili::NaytaTiedot()
{
  cout << endl << "Tilinumero: " << tilinumero_ << endl << "Asiakkaan nimi: " << nimi_ << endl << "Tilin saldo: " << saldo_ << endl;
}

int Asiakastili::MuutaSaldoa(int saldo)
{
  saldo_ = saldo;
  return saldo_;
}

int Asiakastili::VertaaTiliNro(int tilinumero)
{
  if (tilinumero_ == tilinumero)
  {
    return 1;
  }
  else
  {
  return 0;
  }
}

int main() {
  int valinta, tilin_nro, uusi_saldo, i;
  bool loytyi;
  Asiakastili asiakasrekisteri[5];

  asiakasrekisteri[0].LisaaAsiakas(12345, 312, "Mikko Möttönen");
  asiakasrekisteri[1].LisaaAsiakas(23456, 23, "Anni Manninen");
  asiakasrekisteri[2].LisaaAsiakas(34567, 112, "Simo Siili");
  asiakasrekisteri[3].LisaaAsiakas(45678, 99834, "Riku Rikas");
  asiakasrekisteri[4].LisaaAsiakas(56789, 7500, "Marja Mallikas");

  do {
    cout << endl << "1: Näytä asiakkaan tiedot." << endl;
    cout << "2: Muuta asiakkaan saldoa." << endl;
    cout << "Lopetus negatiivisella luvulla." << endl;
    cout << "Valitse toiminto: ";
    cin >> valinta;

    if(valinta == 1) {
      cout << "Anna tilinumero: " << endl;
      cin >> tilin_nro;
//** ---------- ---------- ---------- **//

      loytyi = false;
      for(int a=0; a<5; a++)
      {
        if(asiakasrekisteri[a].VertaaTiliNro(tilin_nro))
        {
          loytyi = true;
          asiakasrekisteri[a].NaytaTiedot();
          break;
        }
      }

//** Pre-defined code in the assignment **//
      if(loytyi == false) {
        cout << endl << "Antamaasi tilinumeroa ei löytynyt." << endl;
      }
      loytyi = 0;
    } else if(valinta == 2){
      cout << "Anna tilinumero: ";
      cin >> tilin_nro;
      cout << "Anna uusi saldo:";
      cin >> uusi_saldo;

      for(int i=0; i<5; i++) {

        if(asiakasrekisteri[i].VertaaTiliNro(tilin_nro) == 1) {

          loytyi = true;
          asiakasrekisteri[i].MuutaSaldoa(uusi_saldo);
          cout << endl << "Saldo muutettu." << endl;
        }
      }
      if(loytyi == false) {
        cout << endl << "Antamaasi tilinumeroa ei löytynyt." << endl;
      }
      loytyi = false;

    } else {
      cout << endl << "Ohjelma lopetetaan.";
    }
  }
  while(valinta>0);
}
//** ---------- ---------- ---------- **//
```
