## 1 Oletusmuodostimen rakentaminen

**Tehtävä:**

Tässä tehtävässä sinun tulee kirjoittaa oletusmuodostimen toteutus luokalle "Piste", joka sisältää kokonaislukutyypin jäsenmuuttujat "x_" ja "y_".
Luokan "Piste" toteutus on olemassa - sinun tarvitsee siis kirjoittaa vain ja ainoastaan siihen liitettävä oletusmuodostin,
joka alustaa jäsenmuuttujan "x_" arvolla 1 ja jäsenmuuttujan "y_" arvolla 1. Oletusmuodostin on esitelty valmiiksi luokan määrittelyssä.

Luokkaa ja sen oletusmuodostinta testataan seuraavassa esitetyllä pääohjelmalla (älä kopioi pääohjelmaa vastaukseesi):

```
int main()
{
  Piste  pisteolio;
  pisteolio.TulostaPiste();
  return  0;
}
```

Example output:

```
Pisteen x-koordinaatti: 1
Pisteen y-koordinaatti: 1
```

**Vastaus:**

```
//** Pre-defined code in the assignment **//
#include<iostream>
using namespace std;

class Piste
{
public:
    Piste();
    void TulostaPiste();
    void AsetaPiste(int x, int y);

private:
    int x_;
    int y_;
};

void Piste::TulostaPiste()
{
    cout << "Pisteen x-koordinaatti: " << x_ << endl;
    cout << "Pisteen y-koordinaatti: " << y_ << endl;
}

void Piste::AsetaPiste(int x, int y)
{
    x_ = x;
    y_ = y;
}
//** ---------- ---------- ---------- **//

Piste::Piste() : x_(1), y_(1)
{
}

//** Pre-defined code in the assignment **//
int main()
{
    Piste pisteolio;
    pisteolio.TulostaPiste();
    return 0;
}
//** ---------- ---------- ---------- **//
```
